/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the CreateTaskDataElement type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateTaskDataElement{}

// CreateTaskDataElement struct for CreateTaskDataElement
type CreateTaskDataElement struct {
	BlockId *string `json:"block_id,omitempty"`
	AssetId *string `json:"asset_id,omitempty"`
}

// NewCreateTaskDataElement instantiates a new CreateTaskDataElement object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateTaskDataElement() *CreateTaskDataElement {
	this := CreateTaskDataElement{}
	return &this
}

// NewCreateTaskDataElementWithDefaults instantiates a new CreateTaskDataElement object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateTaskDataElementWithDefaults() *CreateTaskDataElement {
	this := CreateTaskDataElement{}
	return &this
}

// GetBlockId returns the BlockId field value if set, zero value otherwise.
func (o *CreateTaskDataElement) GetBlockId() string {
	if o == nil || IsNil(o.BlockId) {
		var ret string
		return ret
	}
	return *o.BlockId
}

// GetBlockIdOk returns a tuple with the BlockId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateTaskDataElement) GetBlockIdOk() (*string, bool) {
	if o == nil || IsNil(o.BlockId) {
		return nil, false
	}
	return o.BlockId, true
}

// HasBlockId returns a boolean if a field has been set.
func (o *CreateTaskDataElement) HasBlockId() bool {
	if o != nil && !IsNil(o.BlockId) {
		return true
	}

	return false
}

// SetBlockId gets a reference to the given string and assigns it to the BlockId field.
func (o *CreateTaskDataElement) SetBlockId(v string) {
	o.BlockId = &v
}

// GetAssetId returns the AssetId field value if set, zero value otherwise.
func (o *CreateTaskDataElement) GetAssetId() string {
	if o == nil || IsNil(o.AssetId) {
		var ret string
		return ret
	}
	return *o.AssetId
}

// GetAssetIdOk returns a tuple with the AssetId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateTaskDataElement) GetAssetIdOk() (*string, bool) {
	if o == nil || IsNil(o.AssetId) {
		return nil, false
	}
	return o.AssetId, true
}

// HasAssetId returns a boolean if a field has been set.
func (o *CreateTaskDataElement) HasAssetId() bool {
	if o != nil && !IsNil(o.AssetId) {
		return true
	}

	return false
}

// SetAssetId gets a reference to the given string and assigns it to the AssetId field.
func (o *CreateTaskDataElement) SetAssetId(v string) {
	o.AssetId = &v
}

func (o CreateTaskDataElement) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateTaskDataElement) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.BlockId) {
		toSerialize["block_id"] = o.BlockId
	}
	if !IsNil(o.AssetId) {
		toSerialize["asset_id"] = o.AssetId
	}
	return toSerialize, nil
}

type NullableCreateTaskDataElement struct {
	value *CreateTaskDataElement
	isSet bool
}

func (v NullableCreateTaskDataElement) Get() *CreateTaskDataElement {
	return v.value
}

func (v *NullableCreateTaskDataElement) Set(val *CreateTaskDataElement) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateTaskDataElement) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateTaskDataElement) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateTaskDataElement(val *CreateTaskDataElement) *NullableCreateTaskDataElement {
	return &NullableCreateTaskDataElement{value: val, isSet: true}
}

func (v NullableCreateTaskDataElement) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateTaskDataElement) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


